#include "elvees_pci_public.h"

#define ELVEES_PMSC_CONF_SIZE	0x80

#define ELVEES_MAXIMUM_TRANSFER_LENGTH		(4 * 65536)
#define ELVESS_SRAM_SIZE					(4 * 0x20000)

//
//   (,    )
//
typedef struct _DEVICE_CONTEXT
{
	PHYSICAL_ADDRESS	pciBaseAddrPhy;
	ULONG				pciWindowLen;
	PVOID				pciBaseAddrSys;

	WDFDMAENABLER       DmaEnabler;
	ULONG               MaximumTransferLength;

	WDFDMATRANSACTION   WriteDmaTransaction;
	ULONG               WriteTransferElements;

	WDFDMATRANSACTION   ReadDmaTransaction;
	ULONG               ReadTransferElements;

} DEVICE_CONTEXT, *PDEVICE_CONTEXT;

WDF_DECLARE_CONTEXT_TYPE_WITH_NAME(DEVICE_CONTEXT, GetContext)

//
// The context structure used with WdfDmaTransactionCreate
//
typedef struct TRANSACTION_CONTEXT {

	WDFREQUEST		Request;
	UINT32			ElveesAddress;
} TRANSACTION_CONTEXT, *PTRANSACTION_CONTEXT;

WDF_DECLARE_CONTEXT_TYPE_WITH_NAME(TRANSACTION_CONTEXT, GetTransactionContext)

//
//   
//
NTSTATUS
ElveesDeviceCreate(
    PWDFDEVICE_INIT DeviceInit
    );

//
//  ,   
//
EVT_WDF_OBJECT_CONTEXT_CLEANUP		PciDrvEvtDriverContextCleanup;
EVT_WDF_IO_QUEUE_IO_DEVICE_CONTROL	ElveesEvtIoDeviceControl;
EVT_WDF_IO_QUEUE_IO_WRITE			ElveesEvtIoWrite;
EVT_WDF_DEVICE_PREPARE_HARDWARE		ElveesEvtDevicePrepareHardware;
EVT_WDF_DEVICE_RELEASE_HARDWARE		ElveesEvtDeviceReleaseHardware;
EVT_WDF_DEVICE_D0_ENTRY				ElveesEvtD0Entry;


//        PCI
//   MCB    
NTSTATUS
ElveesEnablePciWindowAccess(
	IN WDFDEVICE device
);

NTSTATUS
ElveesInitializeDma(
	IN WDFDEVICE device
);

BOOLEAN
ElveesEvtProgramDma(
	IN  WDFDMATRANSACTION       Transaction,
	IN  WDFDEVICE               Device,
	IN  PVOID                   Context,
	IN  WDF_DMA_DIRECTION       Direction,
	IN  PSCATTER_GATHER_LIST    SgList
);