#ifndef __USER__H
#define __USER__H

//
//  IoControl   Elvees MCB
//

#define FSCTL_ELVEES_BASE      0xa000

#define _ELVEES_CTL_CODE(_Function, _access)  \
            CTL_CODE(FSCTL_ELVEES_BASE, _Function, METHOD_BUFFERED, _access)

//       .
// InBuffer   32-     
//    MCB (    ).
//    OutputBufferLength .
#define IOCTL_ELVEES_READ_AREA		_ELVEES_CTL_CODE(0x201, FILE_READ_ACCESS)

//       .
// InBuffer   32-     
//    MCB (    ),
//     .     
// (InputBufferLength - 4)  .
#define IOCTL_ELVEES_WRITE_AREA		_ELVEES_CTL_CODE(0x202, FILE_WRITE_ACCESS)

//          DMA
// (Bus Mastering).
// InBuffer   32-     
//    MCB (    ).
//    OutputBufferLength .
#define IOCTL_ELVEES_READ_AREA_DMA	\
	CTL_CODE(FSCTL_ELVEES_BASE, 0x203, METHOD_OUT_DIRECT, FILE_READ_ACCESS)

//          DMA
// (Bus Mastering).
// InBuffer   32-     
//    MCB (    ),
//     .     
// (InputBufferLength - 4)  .
#define IOCTL_ELVEES_WRITE_AREA_DMA	\
	CTL_CODE(FSCTL_ELVEES_BASE, 0x204, METHOD_IN_DIRECT, FILE_WRITE_ACCESS)



#endif // __USER__H